import _objectWithoutProperties from "@babel/runtime/helpers/builtin/es6/objectWithoutProperties";
import * as React from 'react';
import State from './State';
import renderProps from '../utils/renderProps';

var add = function add(value) {
  return function (prev) {
    return {
      count: prev.count + value
    };
  };
};

var Counter = function Counter(_ref) {
  var _ref$initial = _ref.initial,
      initial = _ref$initial === void 0 ? 0 : _ref$initial,
      onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, ["initial", "onChange"]);

  return React.createElement(State, {
    initial: {
      count: initial
    },
    onChange: onChange
  }, function (_ref2) {
    var state = _ref2.state,
        setState = _ref2.setState;
    return renderProps(props, {
      count: state.count,
      inc: function inc() {
        return setState(add(1));
      },
      dec: function dec() {
        return setState(add(-1));
      },
      incBy: function incBy(value) {
        return setState(add(value));
      },
      decBy: function decBy(value) {
        return setState(add(-value));
      }
    });
  });
};

export default Counter;