import _objectWithoutProperties from "@babel/runtime/helpers/builtin/es6/objectWithoutProperties";
import * as React from 'react';
import State from './State';
import renderProps from '../utils/renderProps';

var Focus = function Focus(_ref) {
  var onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, ["onChange"]);

  return React.createElement(State, {
    initial: {
      isFocused: false
    },
    onChange: onChange
  }, function (_ref2) {
    var state = _ref2.state,
        setState = _ref2.setState;
    return renderProps(props, {
      isFocused: state.isFocused,
      bind: {
        onFocus: function onFocus() {
          return setState({
            isFocused: true
          });
        },
        onBlur: function onBlur() {
          return setState({
            isFocused: false
          });
        }
      }
    });
  });
};

export default Focus;