import _objectWithoutProperties from "@babel/runtime/helpers/builtin/es6/objectWithoutProperties";
import * as React from 'react';
import State from './State';
import renderProps from '../utils/renderProps';

var Hover = function Hover(_ref) {
  var onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, ["onChange"]);

  return React.createElement(State, {
    initial: {
      isHovered: false
    },
    onChange: onChange
  }, function (_ref2) {
    var state = _ref2.state,
        setState = _ref2.setState;
    return renderProps(props, {
      isHovered: state.isHovered,
      bind: {
        onMouseEnter: function onMouseEnter() {
          return setState({
            isHovered: true
          });
        },
        onMouseLeave: function onMouseLeave() {
          return setState({
            isHovered: false
          });
        }
      }
    });
  });
};

export default Hover;