import _toConsumableArray from "@babel/runtime/helpers/builtin/es6/toConsumableArray";
import _objectWithoutProperties from "@babel/runtime/helpers/builtin/es6/objectWithoutProperties";
import * as React from 'react';
import State from './State';
import renderProps from '../utils/renderProps';
import _set from '../utils/set';

var complement = function complement(fn) {
  return function () {
    return !fn.apply(void 0, arguments);
  };
};

var List = function List(_ref) {
  var _ref$initial = _ref.initial,
      initial = _ref$initial === void 0 ? [] : _ref$initial,
      onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, ["initial", "onChange"]);

  return React.createElement(State, {
    initial: {
      list: initial
    },
    onChange: onChange
  }, function (_ref2) {
    var state = _ref2.state,
        setState = _ref2.setState;
    return renderProps(props, {
      list: state.list,
      first: function first() {
        return state.list[0];
      },
      last: function last() {
        return state.list[Math.max(0, state.list.length - 1)];
      },
      set: function set(list) {
        return setState(function (s) {
          return {
            list: _set(list, s.list)
          };
        });
      },
      push: function push(value) {
        return setState(function (s) {
          return {
            list: _toConsumableArray(s.list).concat([value])
          };
        });
      },
      pull: function pull(predicate) {
        return setState(function (s) {
          return {
            list: s.list.filter(complement(predicate))
          };
        });
      },
      sort: function sort(compareFn) {
        return setState(function (s) {
          return {
            list: _toConsumableArray(s.list).sort(compareFn)
          };
        });
      }
    });
  });
};

export default List;