import _objectWithoutProperties from "@babel/runtime/helpers/builtin/es6/objectWithoutProperties";
import * as React from 'react';
import State from './State';
import renderProps from '../utils/renderProps';

var Touch = function Touch(_ref) {
  var onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, ["onChange"]);

  return React.createElement(State, {
    initial: {
      isTouched: false
    },
    onChange: onChange
  }, function (_ref2) {
    var state = _ref2.state,
        setState = _ref2.setState;
    return renderProps(props, {
      isTouched: state.isTouched,
      bind: {
        onTouchStart: function onTouchStart() {
          return setState({
            isTouched: true
          });
        },
        onTouchEnd: function onTouchEnd() {
          return setState({
            isTouched: false
          });
        }
      }
    });
  });
};

export default Touch;