"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var React = _interopRequireWildcard(require("react"));

var _State = _interopRequireDefault(require("./State"));

var _renderProps = _interopRequireDefault(require("../utils/renderProps"));

var _set2 = _interopRequireDefault(require("../utils/set"));

var complement = function complement(fn) {
  return function () {
    return !fn.apply(void 0, arguments);
  };
};

var List = function List(_ref) {
  var _ref$initial = _ref.initial,
      initial = _ref$initial === void 0 ? [] : _ref$initial,
      onChange = _ref.onChange,
      props = (0, _objectWithoutProperties2.default)(_ref, ["initial", "onChange"]);
  return React.createElement(_State.default, {
    initial: {
      list: initial
    },
    onChange: onChange
  }, function (_ref2) {
    var state = _ref2.state,
        setState = _ref2.setState;
    return (0, _renderProps.default)(props, {
      list: state.list,
      first: function first() {
        return state.list[0];
      },
      last: function last() {
        return state.list[Math.max(0, state.list.length - 1)];
      },
      set: function set(list) {
        return setState(function (s) {
          return {
            list: (0, _set2.default)(list, s.list)
          };
        });
      },
      push: function push(value) {
        return setState(function (s) {
          return {
            list: (0, _toConsumableArray2.default)(s.list).concat([value])
          };
        });
      },
      pull: function pull(predicate) {
        return setState(function (s) {
          return {
            list: s.list.filter(complement(predicate))
          };
        });
      },
      sort: function sort(compareFn) {
        return setState(function (s) {
          return {
            list: (0, _toConsumableArray2.default)(s.list).sort(compareFn)
          };
        });
      }
    });
  });
};

var _default = List;
exports.default = _default;